#include "testlib.h"
#include <iostream>
#include <unordered_set>

using namespace std;

struct edge{
    int v, w; char c;
    edge(){}
    edge(int v, int w, char c) : v(v), w(w), c(c) {}
};

set <pair <int, int>> wb, wr;

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int red = atoi(argv[2]);
    int black = atoi(argv[3]);
    int qs = atoi(argv[4]);
    int t = atoi(argv[5]);

    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        if (i > 0) p[i] = rnd.wnext(i, t);
    }
    vector<int> perm(n);
    for (int i = 0; i < n; i++) {
        perm[i] = i;
    }
    shuffle(perm.begin() + 1, perm.end());
    vector<edge> reds;
    for (int i = 1; i < n; i++) {
        if (rnd.next(2)) {
            reds.emplace_back(perm[i], perm[p[i]], 'T');
        } else {
            reds.emplace_back(perm[p[i]], perm[i], 'T');
        }
        wr.insert({perm[i], perm[p[i]]});
    }
    for (int i = 0; i < red; i++) {
        int v = rnd.next(n), w = v;
        while (v == w || wr.count({v, w}) || wr.count({w, v})) {
            w = rnd.next(n);
        }
        wr.insert({v, w});
        reds.emplace_back(w, v, 'T');
    }
    vector <edge> blacks;
    for (int i = 0; i < black; i++) {
        int a = rnd.wnext(n, t), b = a;
        while (b == a || wb.count({a, b}) || wb.count({b, a})) {
            b = rnd.next(n);
        }
        wb.insert({a, b});
        blacks.emplace_back(a, b, 'F');
    }

    int const N = 100000;
    int r = rnd.next(0, N + 1);
    int b = rnd.next(0, N + 1);
    r = min(r, (int)reds.size());
    b = min(b, (int)blacks.size());
    while ((int)reds.size() + blacks.size() - r - b + qs > N) {
        r = rnd.next(0, N + 1);
        b = rnd.next(0, N + 1);
        r = min(r, (int)reds.size());
        b = min(b, (int)blacks.size());

    }
    //r = min(r, (int)reds.size());
    //r = max(r, m - (int)blacks.size());
    //cout << n << ' ' << m - r << ' ' << r << '\n';
    cout << n << ' ' << b << ' ' << r << '\n';
    for (int i = 0; i < b; i++) {
        cout << blacks.back().v + 1 << ' ' << blacks.back().w + 1 << '\n';
        blacks.pop_back();
    }
    for (int i = 0; i < r; i++) {
        cout << reds.back().v + 1 << ' ' << reds.back().w + 1 << '\n';
        reds.pop_back();
    }
    vector <edge> all = reds;
    for (auto i : blacks) all.push_back(i);
    shuffle(all.begin(), all.end());
    cout << all.size() + qs << '\n';
    vector <int> type;
    for (int i = 0; i < qs; i++) type.push_back(1);
    for (int i = 0; i < all.size(); i++) type.push_back(0);
    int cnt = 0;
    shuffle(type.begin(), type.end());
    for (int i : type) {
        if (i) {
            cout << '?' << ' ' << rnd.wnext(n, t) + 1 << '\n';
        } else {
            cout << all[cnt].c << ' ' << all[cnt].v + 1 << ' ' << all[cnt].w + 1 << '\n';
            cnt++;
        }
    }
    return 0;
}