#include "testlib.h"
#include <iostream>
#include <unordered_set>
#include <cassert>

using namespace std;

struct edge{
    int v, w; char c;
    edge() = default;
    edge(int v, int w, char c) : v(v), w(w), c(c) {}
};

set <pair <int, int>> wb, wr;
int const N = 100000;

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);
    int n, m, q;
    n = N / 5;
    m = q = N;

    int peaks = atoi(argv[1]);
    int addreds = atoi(argv[2]);
    set <int> ps;
    for (int i = 0; i < peaks; i++) {
        ps.insert(rnd.next(n));

    }
    assert(peaks * (n - peaks) <= N);
    vector <edge> all;
    for (int i : ps) {
        cerr << i << '\n';
        for (int j = 0; j < n; j++) if (!ps.count(j)) {
                all.emplace_back(i, j, 'B');
                wb.insert({i, j});
            }
    }
    int k = m - all.size();
    cout << n << ' ' << all.size() << ' ' << m - all.size() << '\n';
    shuffle(all.begin(), all.end());
    for (auto& e : all) {
        if (rnd.next(2) == 1) swap(e.v, e.w);
        cout << e.v + 1 << ' ' << e.w + 1 << '\n';
    }
    all.clear();
    for (int qq = 0; qq < k; qq++) {
        int v, w;
        v = w = -1;
        while (w == v || wr.count({w, v}) || wr.count({v, w})) {
            w = rnd.next(n);
            v = rnd.next(n);
        }
        wr.insert({v, w});
        all.emplace_back(v, w, 'R');
    }
    shuffle(all.begin(), all.end());
    for (auto& e : all) {
        if (rnd.next(2) == 1) swap(e.v, e.w);
        cout << e.v + 1 << ' ' << e.w + 1 << '\n';
    }
    vector <int> type;
    all.assign({});
    for (int i = 0; i < addreds; i++) {
        int v, w;
        v = w = -1;
        while (w == v || wr.count({w, v}) || wr.count({v, w})) {
            w = rnd.next(n);
            v = rnd.next(n);
        }
        wr.insert({v, w});
        all.emplace_back(v, w, 'T');
    }
    assert(all.size() == addreds);
    for (int i = 0; i < addreds; i++) type.push_back(1);
    for (int i = 0; i < q - addreds; i++) type.push_back(0);
    int cnt = 0;

    shuffle(type.begin(), type.end());

    assert(type.size() == N);
    vector <int> psv;
    for (int i : ps) psv.push_back(i);
    cout << q << '\n';
    for (int i : type) {
        if (!i) {
            cout << '?' << ' ' << psv[rnd.next(peaks)] + 1 << '\n';
        } else {
            assert(!all.empty());
            if (rnd.next(2) == 1) swap(all.back().v, all.back().w);
            assert(all.back().c == 'T');
            cout << all.back().c << ' ' << all.back().v + 1 << ' ' << all.back().w + 1 << '\n';
            all.pop_back();
        }
    }
    return 0;
}