#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> par;

template <typename T>
void init(int n, T & t) {
    t.assign(n, 0);
}

template <typename T, typename ... Ts>
void init(int n, T& t, Ts& ... ts) {
    t.assign(n, 0);
    init(n, ts...);
}

int const N = 100100;
vector <int> reds[N];
vector <int> blacks[N];
vector <char> used;

void dfs(int v) {
    used[v] = 1;
    for (int to : reds[v]) if (!used[to]) dfs(to);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        int v, w;
        cin >> v >> w;
        v--; w--;
            blacks[v].push_back(w);
            blacks[w].push_back(v);
    
    }
    for (int i = 0; i < k; i++) {
        int v, w;
        cin >> v >> w;
        v--; w--;
            reds[v].push_back(w);
            reds[w].push_back(v);
    
    }
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        char type;
        cin >> type;
        if (type == 'F') {
            int v, w;
            cin >> v >> w;
            v--; w--;
            blacks[v].push_back(w);
            blacks[w].push_back(v);
        } else if (type == 'T') {
            int v, w;
            cin >> v >> w;
            v--; w--;
            reds[v].push_back(w);
            reds[w].push_back(v);
        } else {
            int v;
            cin >> v;
            v--;
            used.assign(n, 0);
            dfs(v);
            int ans = 0;
            for (int to : blacks[v]) if (used[to]) ans++;
            cout << ans << '\n';
        }
    }
    return 0;
}