#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> par;

template <typename T>
void init(int n, T & t) {
    t.assign(n, 0);
}

template <typename T, typename ... Ts>
void init(int n, T& t, Ts& ... ts) {
    t.assign(n, 0);
    init(n, ts...);
}

int const N = 100100;
int const len = 610;

unordered_map<int, int> g[N];
vector <int> sz, pr;
vector <par> delayed;
vector <vector <int>> small;
unordered_set<int> used;

int root(int v) {
    return (pr[v] == v) ? v : pr[v] = root(pr[v]);
}

void unite(int v, int u) {
    v = root(v); u = root(u);
    if (v != u) {
        if (sz[v] > sz[u]) {
            swap(v, u);
        }
        sz[u] += sz[v];
        pr[v] = u;
    }
}

void dfs(int v) {
    used.insert(v);
    for (int to : small[v]) {
        if (!used.count(to)) {
            dfs(to);
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    sz.assign(n, 1);
    pr.resize(n);
    small.assign(n, {});
    for (int i = 0; i < n; i++) pr[i] = i;
    for (int i = 0; i < m; i++) {
        int v, w;
        cin >> v >> w;
        v--; w--;
        delayed.emplace_back(v, w);
    }
    for (int i = 0; i < k; i++) {
        int v, w;
        cin >> v >> w;
        v--; w--;
        unite(v, w);
    }
    for (auto e : delayed) {
        g[e.first][root(e.second)]++;
        g[e.second][root(e.first)]++;
    }
    delayed.clear();
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        if (delayed.size() >= len) {
            for (auto e : delayed) {
                unite(e.first, e.second);
            }
            delayed.clear();
            small.assign(n, {});
            for (int i = 0; i < n; i++) {
                vector <int> marked;
                vector <par> adders;
                for (auto& el : g[i]) {
                    if (root(el.first) != el.first) {
                        adders.emplace_back(root(el.first), el.second);
                        marked.push_back(el.first);
                    }
                }
                for (int el : marked) g[i].erase(el);
                for (par el : adders) g[i][el.first] += el.second;
            }
        }
        char type;
        cin >> type;
        if (type == 'F') {
            int v, w;
            cin >> v >> w;
            v--; w--;
            g[v][root(w)]++;
            g[w][root(v)]++;
        } else if (type == 'T') {
            int v, w;
            cin >> v >> w;
            v--; w--;
            delayed.emplace_back(v, w);
            if (root(v) != root(w)) {
                small[root(v)].push_back(root(w));
                small[root(w)].push_back(root(v));
            }
        } else {
            int v;
            cin >> v;
            v--;
            int c = root(v);
            used.clear();
            dfs(c);
            int ans = 0;
            for (int to : used) {
                ans += g[v][root(to)];
            }
            cout << ans << '\n';
        }
    }
    return 0;
}