#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = int(1e9);
const int MAXT = int(1e9);

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int x = inf.readInt(2, MAXN, "x");
    inf.readSpace();
    int y = inf.readInt(2, MAXN, "y");
    inf.readSpace();
    int z = inf.readInt(2, MAXN, "z");
    inf.readEoln();
    int len[3] = {x, y, z};

    int a = inf.readInt(1, x - 1, "a");
    inf.readSpace();
    int b = inf.readInt(1, y - 1, "b");
    inf.readSpace();
    int c = inf.readInt(1, z - 1, "c");
    inf.readEoln();
    
    map<pair<int, int>, pair<int, int>> croses;
    croses[{0, a}] = {1, b + 1};
    croses[{0, a + 1}] = {2, c};
    
    croses[{1, b}] = {2, c + 1};
    croses[{1, b + 1}] = {0, a};

    croses[{2, c}] = {0, a + 1};
    croses[{2, c + 1}] = {1, b};


    int t1 = inf.readInt(1, MAXT, "t1");
    inf.readSpace();
    int t2 = inf.readInt(1, MAXT, "t2");
    inf.readSpace();
    int t3 = inf.readInt(1, MAXT, "t3");
    inf.readSpace();
    int d = inf.readInt(1, MAXT, "d");
    inf.readEoln();
    
    int k = inf.readInt(1, 3, "k");
    inf.readSpace();
    int i = inf.readInt(1, len[k - 1], "i");
    inf.readSpace();
    int l = inf.readInt(1, 3, "l");
    inf.readSpace();
    int j = inf.readInt(1, len[l - 1], "j");
    inf.readEoln();
    
    //ensuref(k != l, "k = l");
    ensuref(k != l || i != j, "Start and finish the same station");
    ensuref(croses[{k - 1, i}] != make_pair(l - 1, j), 
        "%d station on %d line has cross to %d station on %d line", i, k, j, l);
    ensuref(croses[{k - 1, i}] == make_pair(0, 0), "Starting station is on line cross");
    ensuref(croses[{l - 1, j}] == make_pair(0, 0), "Destination station is on line cross");
    inf.readEof();
    return 0;
}