// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 9;
 
ll g[N][N];
 
int getId(int line, int num) {
    return line * 3 + num;
}
 
void addEdge(int from, int to, ll cost) {
    g[from][to] = cost;
    g[to][from] = cost;
}
 
void floyd() {
    for (int k = 0; k < N; ++k) {
        for (int i = 0; i < N; ++i) {
            for (int j = 0; j < N; ++j) {
                g[i][j] = std::min(g[i][j], g[i][k] + g[k][j]);
            }
        }
    }
}
 
int sh[3];
int t[3];
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    int x, y, z;
    int a, b, c;
    int t1, t2, t3, d;
 
    scanf("%d%d%d%d%d%d%d%d%d%d", &x, &y, &z, &a, &b, &c, &t1, &t2, &t3, &d);
 
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            if (i == j) {
                g[i][j] = 0;
            } else {
                g[i][j] = INF;
            }
        }
    }
 
    addEdge(getId(0, 0), getId(1, 0), d);
    addEdge(getId(1, 1), getId(2, 1), d);
    addEdge(getId(2, 2), getId(0, 2), d);
 
    addEdge(getId(0, 0), getId(0, 2), t1);
    addEdge(getId(1, 0), getId(1, 1), t2);
    addEdge(getId(2, 1), getId(2, 2), t3);
 
    floyd();
 
    int k, i, l, j;
    scanf("%d%d%d%d", &k, &i, &l, &j);
 
    --k;
    --i;
    --l;
    --j;
 
    --a;
    --b;
    --c;
 
    sh[0] = a;
    sh[1] = b;
    sh[2] = c;
 
    t[0] = t1;
    t[1] = t2;
    t[2] = t3;
 
    if (k == l) {
        if (k == 0) {
            if (std::max(i, j) <= a || std::min(i, j) >= a + 1) {
                printf("%lld\n", 1ll * llabs(i - j) * t1);
                return 0;
            }
        } else if (k == 1) {
            if (std::max(i, j) <= b || std::min(i, j) >= b + 1) {
                printf("%lld\n", 1ll * llabs(i - j) * t2);
                return 0;
            }
        } else {
            if (std::max(i, j) <= c || std::min(i, j) >= c + 1) {
                printf("%lld\n", 1ll * llabs(i - j) * t3);
                return 0;
            }
        }
    }
 
    ll ans = 0;
    int v1, v2;
 
    if (i <= sh[k]) {
        ans += 1ll * t[k] * llabs(sh[k] - i);
 
        if (k == 0) {
            v1 = getId(0, 0);
        } else if (k == 1) {
            v1 = getId(1, 1);
        } else {
            v1 = getId(2, 2);
        }
    } else {
        ans += 1ll * t[k] * llabs(sh[k] + 1 - i);
 
        if (k == 0) {
            v1 = getId(0, 2);
        } else if (k == 1) {
            v1 = getId(1, 0);
        } else {
            v1 = getId(2, 1);
        }
    }
 
    if (j <= sh[l]) {
        ans += 1ll * t[l] * llabs(sh[l] - j);
 
        if (l == 0) {
            v2 = getId(0, 0);
        } else if (l == 1) {
            v2 = getId(1, 1);
        } else {
            v2 = getId(2, 2);
        }
    } else {
        ans += 1ll * t[l] * llabs(sh[l] + 1 - j);
 
        if (l == 0) {
            v2 = getId(0, 2);
        } else if (l == 1) {
            v2 = getId(1, 0);
        } else {
            v2 = getId(2, 1);
        }
    }   
 
    ans += g[v1][v2];
 
    printf("%lld\n", ans);
 
    return 0;
}
