//  Copyright 2019 Nikita Golikov

#include <bits/stdc++.h>

#define BITSET_ITER(i, bt) for (auto i = bt._Find_first(); i != bt.size();\
i = bt._Find_next(i))

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::queue;
using std::deque;
using std::stack;
using std::string;
using std::map;
using std::set;
using std::pair;
using std::tuple;
using std::unique_ptr;
using std::shared_ptr;
using std::unordered_map;
using std::unordered_set;
using std::multiset;
using std::sort;
using std::reverse;
using std::function;
using std::make_pair;
using std::make_tuple;
using i32 = std::int32_t;
using ui32 = std::uint32_t;
using i64 = std::int64_t;
using ui64 = std::uint64_t;

//#ifdef GOLIKOV
//std::mt19937 rng(566);
//#else
//std::mt19937 rng(static_cast<unsigned>(std::chrono::high_resolution_clock::now()
//.time_since_epoch().count()));
//#endif
//
//template <typename T>
//T rnd(T l, T r) {
//  if constexpr (std::is_integral_v<T>) {
//    return std::uniform_int_distribution<T>(l, r)(rng);
//  } else {
//    return std::uniform_real_distribution<T>(l, r)(rng);
//  }
//}
//
//template <typename T>
//auto make_vector() {
//  return T();
//}
//
//template <typename T, typename... Args>
//auto make_vector(size_t n, Args... args) {
//  return vector(n, make_vector<T>(args...));
//}
//
//template <typename... Args>
//void read(Args& ... args) {
//  (cin >> ... >> args);
//}
//
//constexpr bool golikov() {
//#ifdef GOLIKOV
//  return true;
//#else
//  return false;
//#endif
//}
//
//template <bool flush = false>
//void print() {
//  if constexpr (golikov() || flush) {
//    cout << std::endl;
//  } else {
//    cout << '\n';
//  }
//}
//
//template <bool flush = false, typename T, typename... Args>
//void print(T const& x, Args const& ... args) {
//  cout << x;
//  if constexpr (sizeof...(args)) {
//    cout << ' ';
//  }
//  print<flush>(args...);
//}

int main() {
//  if constexpr (golikov()) {
#ifdef GOLIKOV
    std::freopen("in", "rt", stdin);
#endif
//  }
  std::ios::sync_with_stdio(false);
  cin.tie(nullptr);

  i64 nfirst, nsecond, nthird;
  cin >> nfirst >> nsecond >> nthird;
  vector<int> transfer(3);
  for (auto& x : transfer) {
    cin >> x;
  }
  vector<i64> t(3);
  for (auto& x : t) {
    cin >> x;
  }
  i64 d;
  cin >> d;
  i64 const INF = std::numeric_limits<i64>::max();
  vector<vector<i64>> dist(9, vector<i64>(9, INF));
  auto get_v = [](int line, int from) {
    return line * 3 + from;
  };
  for (int line_from = 0; line_from < 3; ++line_from) {
    for (int line_to = 0; line_to < 3; ++line_to) {
      for (int from = 0; from < 3; ++from) {
        for (int to = 0; to < 3; ++to) {
          if (line_from == from || line_to == to) {
            continue;
          }
          i64 cost = 0;
          if (from == to) {
            cost = line_from == line_to ? 0 : d;
          } else {
            int common_line = 3 - from - to;
            if (line_from != common_line) {
              cost += d;
            }
            cost += t[common_line];
            if (line_to != common_line) {
              cost += d;
            }
          }
          dist[get_v(line_from, from)][get_v(line_to, to)] = cost;
        }
      }
    }
  }
  for (int k = 0; k < 9; ++k) {
    for (int i = 0; i < 9; ++i) {
      for (int j = 0; j < 9; ++j) {
        if (dist[i][k] == INF || dist[k][j] == INF) {
          continue;
        }
        dist[i][j] = std::min(dist[i][j], dist[i][k] + dist[k][j]);
      }
    }
  }
  int k, i, l, j;
  cin >> k >> i >> l >> j;
  --k;
  --l;
  auto dist_one_line = [&](int line, int from, int to) {
    return t[line] * std::abs(from - to);
  };
  if (k == l && std::max(i, j) <= transfer[k]) {
    cout << dist_one_line(k, i, j) << '\n';
    return 0;
  }
  if (k == l && std::min(i, j) > transfer[k]) {
    cout << dist_one_line(k, i, j) << '\n';
    return 0;
  }
  //  drive to transfer
  auto left = i <= transfer[k];
  i64 to_first_transfer = dist_one_line(k, i, left ? transfer[k] :
  transfer[k] + 1);
  auto to_left = j <= transfer[l];
  i64 to_second_transfer = dist[get_v(k, left ? 3 - k - ((k + 1) % 3) : 3 -
                                k - ((k + 2) % 3))][get_v(l,
                                                   to_left ? 3 - l - ((l + 1)
                                                   % 3
                                                   ) : 3 - l - ((l + 2) % 3))];
  i64 to_last_station = dist_one_line(l, j, to_left ? transfer[l] :
  transfer[l] + 1);
  cout << to_first_transfer + to_second_transfer + to_last_station << '\n';
  return 0;
}
