#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

void print_masked(vector<unsigned int> const &a, unsigned int mask) {
    vector<unsigned int> res;
    for (unsigned int bit = 0; bit < a.size(); bit++) {
        if ((mask >> bit) & 1u) {
            res.push_back(a[bit] + 1);
        }
    }
    cout << res.size() << '\n';
    for (unsigned int t : res) {
        cout << t << ' ';
    }
    cout << '\n';
}

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    cin >> n >> m;
    vector<unsigned long long> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (unsigned int mask = 1u; mask < (1u << n); mask++) {
        vector<unsigned long long> taken;
        for (unsigned int bit = 0; bit < n; bit++) {
            if ((mask >> bit) & 1u) {
                taken.push_back(a[bit]);
            }
        }
        unsigned int cnt = taken.size();
        for (unsigned int positive = 0; positive < (1u << cnt); positive++) {
            long long sum = 0;
            for (unsigned int bit = 0; bit < cnt; bit++) {
                if ((positive >> bit) & 1u) {
                    sum += taken[bit];
                } else {
                    sum -= taken[bit];
                }
            }

            if (sum % m == 0) {
                vector<unsigned int> bits;
                for (unsigned int bit = 0; bit < n; bit++) {
                    if ((mask >> bit) & 1u) {
                        bits.push_back(bit);
                    }
                }
                print_masked(bits, positive);
                print_masked(bits, ~positive);
                return 0;
            }
        }
    }

    cout << -1 << '\n';

}
