#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    cin >> n >> m;
    vector<unsigned long long> a(n), b(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = a[i] % m;
    }

    vector<vector<bool>> can(n + 1, vector<bool>(m, false));
    vector<vector<int>> prev(n + 1, vector<int>(m, 0));
    can[0][0] = true;
    for (int i = 0; i < n; i++) {
        for (unsigned int j = 0; j < m; j++) {
            if (can[i][j]) {
                unsigned int nxt = (j + b[i]) % m, prv = (j + m - b[i]) % m;
                can[i + 1][j] = true;
                prev[i + 1][j] = 0;
                can[i + 1][nxt] = true;
                prev[i + 1][nxt] = i + 1;
                can[i + 1][prv] = true;
                prev[i + 1][prv] = -i - 1;
            }
        }
        if (can[i + 1][0] && prev[i + 1][0] != 0) {
            int cur = 0, j = i + 1;
            vector<int> res1, res2;
            while (j > 0) {
                if (prev[j][cur] != 0) {
                    int idx = 0, sign = 0;
                    if (prev[j][cur] < 0) {
                        idx = -prev[j][cur] - 1;
                        sign = -1;
                        res1.push_back(idx + 1);
                    } else {
                        sign = 1;
                        idx = prev[j][cur] - 1;
                        res2.push_back(idx + 1);
                    }
                    cur = ((cur - sign * (int) b[idx]) % (int) m + (int) m) % m;
                }
                j--;
            }
            auto print1 = [](vector<int> const &w) {
                cout << w.size() << '\n';
                for (int t : w) {
                    cout << t << ' ';
                }
                cout << '\n';
            };
            print1(res1);
            print1(res2);
            return 0;
        }
    }

    cout << -1 << '\n';

}
