#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

void print_masked(vector<unsigned long long> const &a, unsigned int mask) {
    vector<unsigned int> res;
    for (unsigned int bit = 0; bit < a.size(); bit++) {
        if ((mask >> bit) & 1u) {
            res.push_back(bit + 1);
        }
    }
    cout << res.size() << '\n';
    for (unsigned int t : res) {
        cout << t << ' ';
    }
    cout << '\n';
}

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    cin >> n >> m;
    vector<unsigned long long> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<unsigned int> sum(1u << n);
    vector<unsigned int> cnt(1u << n);
    cnt[0] = sum[0] = 0;
    for (unsigned int i = 0; i < n; i++) {
        sum[1u << i] = a[i] % m;
        cnt[1u << i] = 1;
    }
    vector<unsigned int> fit(m, 0);
    for (unsigned int mask = 1u; mask < (1u << n); mask++) {
        unsigned long long cur = mask & (mask - 1u);
        if (cur != 0) {
            sum[mask] = (sum[cur] + sum[mask ^ cur]) % m;
            cnt[mask] = cnt[cur] + 1;
        }
        unsigned int mod = sum[mask];
        if (mod == 0 || fit[mod]) {
            assert((mask & fit[mod]) == 0);

            print_masked(a, mask);
            print_masked(a, fit[mod]);

            return 0;
        } else {
            fit[mod] = mask;
        }
    }

    cout << "-1\n";

}
