//  Copyright 2019 Nikita Golikov

#include <bits/stdc++.h>

#define BITSET_ITER(i, bt) for (auto i = bt._Find_first(); i != bt.size();\
i = bt._Find_next(i))

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::queue;
using std::deque;
using std::stack;
using std::string;
using std::map;
using std::set;
using std::pair;
using std::tuple;
using std::unique_ptr;
using std::shared_ptr;
using std::unordered_map;
using std::unordered_set;
using std::multiset;
using std::sort;
using std::reverse;
using std::function;
using std::make_pair;
using std::make_tuple;
using i32 = std::int32_t;
using ui32 = std::uint32_t;
using i64 = std::int64_t;
using ui64 = std::uint64_t;

#ifdef GOLIKOV
std::mt19937 rng(566);
#else
std::mt19937 rng(static_cast<unsigned>(std::chrono::high_resolution_clock::now()
        .time_since_epoch()
        .count()));
#endif

template <typename T>
T rnd(T l, T r) {
//  if constexpr (std::is_integral_v<T>) {
    return std::uniform_int_distribution<T>(l, r)(rng);
//  } else {
//    return std::uniform_real_distribution<T>(l, r)(rng);
//  }
}

//template <typename T>
//auto make_vector() {
//  return T();
//}
//
//template <typename T, typename... Args>
//auto make_vector(size_t n, Args... args) {
//  return vector(n, make_vector<T>(args...));
//}

//template <typename... Args>
//void read(Args& ... args) {
//  (cin >> ... >> args);
//}
//
//constexpr bool golikov() {
//#ifdef GOLIKOV
//  return true;
//#else
//  return false;
//#endif
//}
//
//template <bool flush = false>
//void print() {
//  if constexpr (golikov() || flush) {
//    cout << std::endl;
//  } else {
//    cout << '\n';
//  }
//}
//
//template <bool flush = false, typename T, typename... Args>
//void print(T const& x, Args const& ... args) {
//  cout << x;
//  if constexpr (sizeof...(args)) {
//    cout << ' ';
//  }
//  print<flush>(args...);
//}

int main() {
//  if constexpr (golikov()) {
#ifdef GOLIKOV
    std::freopen("in", "rt", stdin);
#endif
//  }
  std::ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, m;
  cin >> n >> m;

  vector<int> a_original(n);
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a_original[i];
    a[i] = a_original[i] % m;
    if (a[i] < 0) {
      a[i] += m;
    }
  }

  auto left = n / 2;
  auto right = n - left;

  vector<int> pw(std::max(left, right) + 1);
  pw[0] = 1;
  for (int i = 1; i < (int) pw.size(); ++i) {
    pw[i] = 3 * pw[i - 1];
  }
  //  1 - plus
  //  2 - minus
  vector<int> can_left(m, -1);
  for (int mask = 0; mask < pw[left]; ++mask) {
    int s = 0;
    auto cur_mask = mask;
    for (int i = 0; i < left; ++i) {
      auto r = cur_mask % 3;
      if (r == 1) {
        s += a[i];
      } else if (r == 2) {
        s -= a[i];
      }
      s %= m;
      if (s < 0) {
        s += m;
      }
      cur_mask /= 3;
    }
    can_left[s] = mask;
  }
  vector<int> can_right(m, -1);
  for (int mask = 0; mask < pw[right]; ++mask) {
    int s = 0;
    auto cur_mask = mask;
    for (int i = 0; i < right; ++i) {
      auto r = cur_mask % 3;
      if (r == 1) {
        s += a[left + i];
      } else if (r == 2) {
        s -= a[left + i];
      }
      s %= m;
      if (s < 0) {
        s += m;
      }
      cur_mask /= 3;
    }
    can_right[s] = mask;
  }
  for (int s_left = 0; s_left < m; ++s_left) {
    if (can_left[s_left] < 0) {
      continue;
    }
    auto s_right = (m - s_left) % m;
    if (can_right[s_right] < 0) {
      continue;
    }
    vector<int> take;
    auto m_left = can_left[s_left];
    auto m_right = can_right[s_right];
    if (!m_left && !m_right) {
      continue;
    }
    for (int i = 0; i < left; ++i) {
      auto r = m_left % 3;
      if (r == 1) {
        take.push_back(i + 1);
      } else if (r == 2 ){
        take.push_back(-i - 1);
      }
      m_left /= 3;
    }
    for (int i = 0; i < right; ++i) {
      auto r = m_right % 3;
      if (r == 1) {
        take.push_back(left + i + 1);
      } else if (r == 2) {
        take.push_back(-left - i - 1);
      }
      m_right /= 3;
    }
    vector<int> lft;
    vector<int> rght;
    for (auto x : take) {
        if (x < 0) {
            lft.push_back(-x);
        } else {
            rght.push_back(x);
        }
    }
    cout << lft.size() << '\n';
    for (int x : lft) {
        cout << x << ' ';
    }
    cout << '\n' << rght.size() << '\n';
    for (int i : rght) {
        cout << i << ' ';
    }
    // cerr << take.size() << '\n';
    // for (auto x : take) {
    //   cerr << x << ' ';
    // }
    // cerr << '\n';
    return 0;
  }
  cout << "-1\n";
  return 0;
}
