#include "testlib.h"
#include <iostream>
#include <string>
#include <vector>
#include <assert.h>
#include <bitset>
#include <random>

#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define sz(a) (int)a.size()

using namespace std;

string shuffleString(string s, vector<int> p) {
	int n = sz(s);
	string res(n, ' ');
	rep(i, 0, n) {
		res[p[i]] = s[i];
	}
	return res;
}

void shuffleTest(string &s, vector<string> &tests) {
	int n = sz(s);
	vector<int> p(n);
	rep(i, 0, n) {
		p[i] = i;
	}
	shuffle(p.begin(), p.end());
	s = shuffleString(s, p);
	rep(i, 0, sz(tests)) {
		tests[i] = shuffleString(tests[i], p);
	}
}

int main(int argc, char* argv[])
{
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int k = atoi(argv[3]);
    assert(k <= n);

    string answer(n, ' ');
    rep(i, 0, n) {
    	answer[i] = char('A' + rnd.next(0, 3));
    }
    vector<string> tests(m);
    rep(i, 0, m) {
    	tests[i] = string(n, ' ');
    	rep(j, 0, n) {
    		if (j < k) {
    			tests[i][j] = char('A' + rnd.next(0, 3));
    		} else {
    			tests[i][j] = answer[j];
    		}
    	}
    }

    shuffleTest(answer, tests);

    cout << n << "\n";
    cout << answer << "\n";
    cout << m << "\n";
    for (auto it : tests) {
    	cout << it << "\n";
    }

    return 0;
}